#include <pwd.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>

int main(int argc, char *argv[]) {
  unsigned long long uid = -1;
  struct passwd *p;
  size_t bufsize;
  char *buf;
  struct passwd p_str;
  int result;

  if (2 != argc)
    exit(EXIT_FAILURE);

  bufsize = sysconf(_SC_GETPW_R_SIZE_MAX);

  if (bufsize == -1) /* Value was indeterminate */
    bufsize = 16384; /* Should be more than enough */

  buf = malloc(bufsize);
  if (buf == NULL) {
    exit(EXIT_FAILURE);
  }

  sscanf(argv[1], "%llu", &uid);

  result = getpwuid_r (uid, &p_str, buf, bufsize, &p);
  if (result == 0 && p == &p_str)
    {
      printf("%llu %llu %s %s", (unsigned long long) p->pw_uid,
             (unsigned long long) p->pw_gid, p->pw_name, p->pw_dir);
      exit(EXIT_SUCCESS);
    }

  exit(EXIT_FAILURE);
}
